/* ct3cs.f -- translated by f2c (version 19990503).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "libtinyf2c.h"

/* ----------------------------------------------------------------------- */
/*     COORDINATE TRANSFORMATION (3D CARTESIAN -> SPHERICAL) */
/*                                              93/02/18   S.SAKAI */
/* ----------------------------------------------------------------------- */
/*     Copyright (C) 2000 GFD Dennou Club. All rights reserved. */
/* ----------------------------------------------------------------------- */
/* Subroutine */ int ct3cs_(real *x, real *y, real *z__, real *r__, real *
	theta, real *phi)
{
    /* Builtin functions */
    double sqrt(doublereal), atan2(doublereal, doublereal);

/*                  0 < THETA < PI */
/*                -PI < PHI   < PI */
    *r__ = sqrt(*x * *x + *y * *y + *z__ * *z__);
    *phi = atan2(*y, *x);
    *theta = atan2(sqrt(*x * *x + *y * *y), *z__);
    return 0;
} /* ct3cs_ */

